[csu/coj 1632]LCP

题意:求一个串的出现次数超过1次的字串的个数

思路:对于一个后缀,出现在它后面的所有后缀与它的LCP的最大值就是应该增加的答案,当然这里没有考虑去重,但是却转化了问题,使得我们可以用最长公共前缀来统计答案。假设我们将每一个后缀按字典序排好,那么对于每一个后缀,与其它后缀的LCP的最大值其实就是与它相邻的两个的lcp的较大值,这不就是height数组了么?考虑去重的问题,如果height[i]>height[i-1],那么对于rank为i和i-1的最长公共前缀,它的前height[i-1]个前缀已经统计过了,答案只需要加上height[i]-height[i-1],如果height[i]<=height[i-1]则不需处理。

  1 #pragma comment(linker, "/STACK:10240000,10240000")
  2
  3 #include <iostream>
  4 #include <cstdio>
  5 #include <algorithm>
  6 #include <cstdlib>
  7 #include <cstring>
  8 #include <map>
  9 #include <queue>
 10 #include <deque>
 11 #include <cmath>
 12 #include <vector>
 13 #include <ctime>
 14 #include <cctype>
 15 #include <set>
 16 #include <bitset>
 17 #include <functional>
 18 #include <numeric>
 19 #include <stdexcept>
 20 #include <utility>
 21
 22 using namespace std;
 23
 24 #define mem0(a) memset(a, 0, sizeof(a))
 25 #define mem_1(a) memset(a, -1, sizeof(a))
 26 #define lson l, m, rt << 1
 27 #define rson m + 1, r, rt << 1 | 1
 28 #define rep_up0(a, b) for (int a = 0; a < (b); a++)
 29 #define rep_up1(a, b) for (int a = 1; a <= (b); a++)
 30 #define rep_down0(a, b) for (int a = b - 1; a >= 0; a--)
 31 #define rep_down1(a, b) for (int a = b; a > 0; a--)
 32 #define all(a) (a).begin(), (a).end()
 33 #define lowbit(x) ((x) & (-(x)))
 34 #define constructInt4(name, a, b, c, d) name(int a = 0, int b = 0, int c = 0, int d = 0): a(a), b(b), c(c), d(d) {}
 35 #define constructInt3(name, a, b, c) name(int a = 0, int b = 0, int c = 0): a(a), b(b), c(c) {}
 36 #define constructInt2(name, a, b) name(int a = 0, int b = 0): a(a), b(b) {}
 37 #define pchr(a) putchar(a)
 38 #define pstr(a) printf("%s", a)
 39 #define sstr(a) scanf("%s", a)
 40 #define sint(a) scanf("%d", &a)
 41 #define sint2(a, b) scanf("%d%d", &a, &b)
 42 #define sint3(a, b, c) scanf("%d%d%d", &a, &b, &c)
 43 #define pint(a) printf("%d\n", a)
 44 #define test_print1(a) cout << "var1 = " << a << endl
 45 #define test_print2(a, b) cout << "var1 = " << a << ", var2 = " << b << endl
 46 #define test_print3(a, b, c) cout << "var1 = " << a << ", var2 = " << b << ", var3 = " << c << endl
 47 #define mp(a, b) make_pair(a, b)
 48 #define pb(a) push_back(a)
 49
 50 typedef unsigned int uint;
 51 typedef long long LL;
 52 typedef pair<int, int> pii;
 53 typedef vector<int> vi;
 54
 55 const int dx[8] = {0, 0, -1, 1, 1, 1, -1, -1};
 56 const int dy[8] = {-1, 1, 0, 0, 1, -1, 1, -1 };
 57 const int maxn = 120000;
 58 const int md = 1000000007;
 59 const int inf = 1e9 + 7;
 60 const LL inf_L = 1e18 + 7;
 61 const double pi = acos(-1.0);
 62 const double eps = 1e-6;
 63
 64 template<class T>T gcd(T a, T b){return b==0?a:gcd(b,a%b);}
 65 template<class T>bool max_update(T &a,const T &b){if(b>a){a = b; return true;}return false;}
 66 template<class T>bool min_update(T &a,const T &b){if(b<a){a = b; return true;}return false;}
 67 template<class T>T condition(bool f, T a, T b){return f?a:b;}
 68 template<class T>void copy_arr(T a[], T b[], int n){rep_up0(i,n)a[i]=b[i];}
 69 int make_id(int x, int y, int n) { return x * n + y; }
 70
 71 /// 构造后缀数组的之前,需要在原串末尾加个空字符(比其它字符都小即可),
 72 ///把这个空字符看成原串的一部分(这样在比较的时候到这个位置一定可以分个大小),
 73 ///所以n应该为原序列长度+1,后缀n-1是"空串",sa[0]总是n-1。
 74 struct SuffixArray {
 75     int n;
 76     int arr[6][maxn];
 77      int *sa, *x, *y, *c, *rnk, *height;
 78     SuffixArray() { sa = arr[0]; x = arr[1]; y = arr[2]; c = arr[3]; rnk = arr[4]; height = arr[5]; }
 79     void resize(int nn) {  n = nn; mem0(arr[0]); }
 80     void build_sa(int s[], int m) { // m is biger than the max value of char
 81         rep_up0(i, m) c[i] = 0;
 82         rep_up0(i, n) c[x[i] = s[i]]++;
 83         rep_up1(i, m - 1) c[i] += c[i - 1];
 84         rep_down0(i, n) sa[--c[x[i]]] = i;
 85         for (int k = 1; k <= n; k <<= 1) {
 86             int p = 0;
 87             for (int i = n - k; i < n; i++) y[p++] = i;
 88             rep_up0(i, n) if (sa[i] >= k) y[p++] = sa[i] - k;
 89             rep_up0(i, m) c[i] = 0;
 90             rep_up0(i, n) c[x[y[i]]]++;
 91             rep_up0(i, m) c[i] += c[i - 1];
 92             rep_down0(i, n) sa[--c[x[y[i]]]] = y[i];
 93             swap(x, y);
 94             p = 1; x[sa[0]] = 0;
 95             for (int i = 1; i < n; i++) {
 96                 x[sa[i]] = y[sa[i - 1]] == y[sa[i]] && y[sa[i - 1] + k] == y[sa[i] + k]? p - 1 : p++;
 97             }
 98             if (p >= n) break;
 99             m = p;
100         }
101     }
102     void build_height(int s[]) {
103         mem0(height);
104         int k = 0;
105         rep_up0(i, n) rnk[sa[i]] = i;
106         rep_up0(i, n) {
107             if (k) k--;
108             int j = sa[rnk[i] - 1];
109             while (s[i + k] == s[j + k]) k++;
110             height[rnk[i]] = k;
111         }
112     }
113     int solve(int n) {
114         int ans = 0;
115         for (int i = 2; i <= n; i ++) {
116             if (height[i] > height[i - 1]) ans += height[i] - height[i - 1];
117         }
118         return ans;
119     }
120 };
121 char s[maxn];
122 int ss[maxn];
123 SuffixArray sa;
124 int main() {
125     //freopen("in.txt", "r", stdin);
126     int T;
127     cin >> T;
128     while (T --) {
129         scanf("%s", s);
130         int len = strlen(s) + 1;
131         rep_up0(i, len) ss[i] = s[i];
132         sa.resize(len);
133         sa.build_sa(ss, 128);
134         sa.build_height(ss);
135         cout << sa.solve(len - 1) << endl;
136     }
137     return 0;
138 }

时间: 2024-10-14 10:53:24

[csu/coj 1632]LCP的相关文章

[csu/coj 1619] 递归

题意:http://acm.csu.edu.cn/OnlineJudge/problem.php?id=1619 思路:由于式子具有递归的性质,考虑递归解,中间结果会超64位int,需用大数.另外自己写了个分数类,见代码. 1 #pragma comment(linker, "/STACK:10240000,10240000") 2 3 #include <iostream> 4 #include <cstdio> 5 #include <algorith

[csu/coj 1079]树上路径查询 LCA

题意:询问树上从u到v的路径是否经过k 思路:把树dfs转化为有根树后,对于u,v的路径而言,设p为u,v的最近公共祖先,u到v的路径必定是可以看成两条路径的组合,u->p,v->p,这样一来便可以将判断条件转化为(LCA(u,k)=k  || LCA(v,k)=k) && LCA(k,p)=p.由于这个LCA询问里面需要用到中间结果p,所以这种方法用tarjan离线不行,只能用dfs+RMQ. 1 #pragma comment(linker, "/STACK:10

[csu/coj 1078]多个序列的最长公共子序列

题意:给n个序列,同一个序列里面元素互不相同,求它们的最长公共子序列. 思路:任取一个序列,对于这个序列里面的两个数ai,aj(i<j),如果对于其它每一个序列,都出现过ai,aj,且ai在aj之前出现,那么i到j连一条长度为1的有向边,完美转化为DAG最长路.需要注意:对于某个数,如果某个序列没出现那么这个点的答案应该为-INF,表示这个点表示的状态不合法. 代码: 1 #pragma comment(linker, "/STACK:10240000,10240000") 2

[csu/coj 1080]划分树求区间前k大数和

题意:从某个区间内最多选择k个数,使得和最大 思路:首先题目给定的数有负数,如果区间前k大出现负数,那么负数不选和更大,于是对于所有最优选择,负数不会出现,所以用0取代负数,问题便转化为区间的前k大数和. 划分树: [1  6  3  8  5  4  7  2] [6  8  5  7][1  3  4  2] [8  7][6  5][3  4][1  2] [8][7][6][5][4][3][2][1] 把快排的结果从上至下依次放入线段树,就构成了划分树,划分的意思就是选定一个数,把原序

[csu/coj 1083]贪心

题意:给定n个线段,问能不能把x,y,z个长度为1,2,3的线段不重合地放进去. 思路:首先如果n个线段长度比要放的长度之和小,则无解,否则先考虑放2和3,如果2和3放下了1肯定可以放下(这是显然的).于是我们贪心先把n个线段放满长度为3的线段,然后再考虑删去长度为3的线段来放长度为2的线段,删的时候要选择删去以后空闲的线段长度最多的删,比如某个线段本身有1的空闲线段,这时如果删去一条放在上面的长度为3的线段,则空闲线段变为4,这种情况优先删,其它情况次之.实现上采用优先队列,保存每个线段的长度

CSU 1804: 有向无环图(拓扑排序)

http://acm.csu.edu.cn/csuoj/problemset/problem?pid=1804 题意:…… 思路:对于某条路径,在遍历到某个点的时候,之前遍历过的点都可以到达它,因此在这个时候对答案的贡献就是∑(a1 + a2 + a3 + ... + ai) * bv,其中a是之前遍历到的点,v是当前遍历的点. 这样想之后就很简单了.类似于前缀和,每次遍历到一个v点,就把a[u]加给a[v],然后像平时的拓扑排序做就行了. 1 #include <bits/stdc++.h>

CSU 1111: 三家人【有趣的思维题】

1111: 三家人 Time Limit: 1 Sec  Memory Limit: 128 MB Submit: 2241  Solved: 874 [Submit][Status][Web Board] Description 有三户人家共拥有一座花园,每户人家的太太均需帮忙整理花园.A 太太工作了5 天,B 太太则工作了4 天,才将花园整理完毕.C 太太因为正身怀六甲无法加入她们的行列,便出了90元.请问这笔钱如何分给A.B 二位太太较为恰当?A 应得多少元?90/(5+4)*5=$50

CSU 1112: 机器人的指令【模拟题】

1112: 机器人的指令 Time Limit: 1 Sec  Memory Limit: 128 MB Submit: 1858  Solved: 682 [Submit][Status][Web Board] Description 数轴原点有一个机器人.该机器人将执行一系列指令,你的任务是预测所有指令执行完毕之后它的位置. ·LEFT:往左移动一个单位 ·RIGHT: 往右移动一个单位 ·SAME AS i: 和第i 条执行相同的动作.输入保证i 是一个正整数,且不超过之前执行指令数 In

hdu 3518 Boring counting 后缀数组LCP

题目链接 题意:给定长度为n(n <= 1000)的只含小写字母的字符串,问字符串子串不重叠出现最少两次的不同子串个数; input: aaaa ababcabb aaaaaa # output 2 3 3 思路:套用后缀数组求解出sa数组和height数组,之后枚举后缀的公共前缀长度i,由于不能重叠,所以计数的是相邻height不满足LCP >= i的. 写写对后缀数组倍增算法的理解: 1.如果要sa数组对应的值也是1~n就需要在最后加上一个最小的且不出现的字符'#',里面y[]是利用sa数